#include <Definitions.h>
#include <log/LogUtils.h>
#include "../../InstanceHandler.h"
#include "VoiceClient.h"

using namespace std;
using namespace ts::server;
using namespace ts::protocol;

void VoiceClient::sendPingRequest() {
    this->lastPingRequest = std::chrono::system_clock::now();

    auto packet = protocol::allocate_outgoing_packet(0);
    packet->ref(); /* extra ref for ourself */

    packet->type_and_flags = (uint8_t) PacketType::PING | (uint8_t) PacketFlag::Unencrypted;
    this->connection->send_packet(packet);

    this->lastPingId = packet->packet_id();
    packet->unref();

#ifdef PKT_LOG_PING
    logMessage(this->getServerId(), "{}[Ping] Sending a ping request with it {}", CLIENT_STR_LOG_PREFIX, this->lastPingId);
#endif
}